
/* checksum

   Get the checksum for a file by adding the bytes and reporting the low 16 bits.

   Copyright 2002  Jed Margolin 

   Permission is given to individuals to make copies for their own use.

   All commercial use requires permission of the author. 
   
   Send comments to:  comments@jmargolin.com

   This program was compiled with Microsoft Visual C++ 6.0 
   to run under Console mode.

   It can also be compiled under Borland Turbo C if you 
   comment out  '#include "stdafx.h' .

*/

#include "stdafx.h"		// comment out to compile under Borland Turbo C
#include <stdio.h>
#include <string.h>

FILE *ifp1;
char fname[100];

int checksum(FILE *);


int main(int argc, char *argv[])
{
	printf("\n\n");
	printf("ROM Checksum Program  Rev 1.1  ");
	printf("Copyright 2002  Jed Margolin\n\n");

	if( (argc<2) )
	{
	   printf("Usage: checksum <binary input file>\n");
	   printf("example: checksum test1.bin\n\n");
	   return(1);
	}

// Input File
	strcpy(fname,argv[1]);

// Open the File
	printf("Input File: %s \n",fname);

	if((ifp1 = fopen(fname,"rb")) == NULL)
	{
	   perror(fname);
	   return(1);
	}

	checksum(ifp1);

	fclose(ifp1);
	printf("\ndone \n\n");

	return(0);
}
//----------------------------------------------------------------------
checksum(FILE *ifp)
{
   int n, nBytes, done=0;
   long int checksum;
   long int number;
   unsigned char buffer[8192];

   checksum = 0;
   nBytes = 0;
   number = 0;
   while(!done)
   {
      nBytes = fread(buffer,1,4096,ifp);
      if(feof(ifp))	   { done=1; }       // end of file 1

      for(n=0;n<nBytes;n++)
      {
	     checksum = checksum + buffer[n];
 	     number++;
      }
   }

   checksum = checksum & 0xFFFF;
   printf("Number of Bytes Read = %ld \n",number);
   printf("Checksum = $%04X \n",checksum);
   return(checksum);
}

